<template>
      <v-container class="fill-height" fluid>
        <v-row align="center" justify="center">
          <v-col cols="12" sm="8" md="4">
            <RegisterForm @registered="handleRegistered"/>
            <Loading :visible="isLoading" />
          </v-col>
        </v-row>
      </v-container>
</template>

<script>
import { mapFields } from 'vuex-map-fields';
import { mapActions } from 'vuex';
import NotificationMixin from '../../mixins/NotificationMixin';
import RegisterForm from '../../components/login/RegisterForm';
import Loading from '../../components/Loading';
const servicePrefix = 'User';

// const { mapFields } = createHelpers({
//   getterType: 'user/getField',
//   mutationType: 'user/updateField'
// });

export default {
  name: 'RegisterView',
  servicePrefix,
  mixins:[NotificationMixin],
  components: {
    RegisterForm,
    Loading
  },
  computed: {
    ...mapFields('user', ['isRegistered', 'error', 'isLoading'])
  },
  methods: {
    handleRegistered(value) {
      this.register(value)
    },
    ...mapActions('user', ['register'])
    
  },
  watch: {
    isRegistered(newInfos) {
      if(newInfos) {
        this.showMessage('Compte crée, veuillez vérifier votre boite mail' , 'warning')
        this.$router.push({name : 'login'});
      }
    },
    error(newError) {
      if (newError) {
        this.showMessage('Erreur lors de la création du compte' , 'error')
      }
    }
  },

};
</script>
